﻿Namespace System.Windows.Controls

   <System.Windows.Markup.ContentProperty("Entries")>
   Public Class IfDataConverter : Implements IValueConverter
      ''' <summary>
      ''' The first entry is the True-Value. False-Value is optional. More entries will be ignored
      ''' </summary>
      Public Property Entries As New List(Of Object)

      Public Function Convert( value As Object,  targetType As Type,  parameter As Object,  culture As Globalization.CultureInfo) As Object Implements IValueConverter.Convert
         If Entries.Count = 0 Then Return value IsNot Nothing
         If value IsNot Nothing Then Return Entries(0)
         Return If(Entries.Count > 1, Entries(1), Nothing)
      End Function
      Public Function ConvertBack( value As Object,  targetType As Type,  parameter As Object,  culture As Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
         Throw New NotImplementedException
      End Function

   End Class

End Namespace
