﻿#Region "FileHeader"
#If False Then
Hiermit kann man die Höhe eines Elementes an ein (Fliesskomma-)Vielfaches einer FontSize binden.
#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Globalization
#End Region 'FileHeader

Namespace System.Windows.Controls
   ''' <summary>
   ''' &lt;Image Height="{Binding  ElementName=myFontSizeRatio, Path=[2.5]}"  /&gt; (Image.Height = 2.5 * FontSize)
   ''' </summary>
   <TypeConverter(GetType(FontSizeRatioConverter))> _
   Public Class FontSizeRatio : Inherits UIElement

      Private _ParentControl As Control = Nothing

      Default Public ReadOnly Property Item(factor As Double) As Double
         Get
            If _ParentControl.Null Then
               _ParentControl = Me.FindParent(Of Control)()
               If _ParentControl.Null Then Return 11 * factor
            End If
            Return _ParentControl.FontSize * factor
         End Get
      End Property

   End Class

   Public Class FontSizeRatioConverter : Inherits TypeConverter

      Public Overrides Function CanConvertFrom(context As ITypeDescriptorContext, sourceType As Type) As Boolean
         Return False
      End Function
      Public Overrides Function CanConvertTo(context As ITypeDescriptorContext, destinationType As Type) As Boolean
         Return destinationType Is GetType(Double) OrElse destinationType Is GetType(String)
      End Function
      Public Overrides Function ConvertFrom(context As ITypeDescriptorContext, culture As CultureInfo, value As Object) As Object
         Throw New InvalidOperationException
      End Function
      Public Overrides Function ConvertTo(context As ITypeDescriptorContext, culture As CultureInfo, value As Object, destinationType As Type) As Object
         Dim size = DirectCast(value, FontSizeRatio).Item(1)
         If destinationType Is GetType(String) Then Return size.ToString
         Return size
      End Function

   End Class

End Namespace
