﻿
Namespace Viewmodel

   Public Class BrushKeyStyleSelector : Inherits StyleSelector

      Private Shared _AllBrushKeyStyles As ResourceDictionary

      Public Overrides Function SelectStyle(item As Object, container As DependencyObject) As Style
         Try
            Return DirectCast(_AllBrushKeyStyles(DirectCast(container, FrameworkElement).DataContext), Style)
         Catch ex As Exception
            Dbg("BrushKeyStyleSelector-fail")
         End Try
         Return MyBase.SelectStyle(item, container)
      End Function

      Shared Sub New()
         _AllBrushKeyStyles = DirectCast(Application.Current.Resources("AllBrushKeyStyles"), ResourceDictionary)
      End Sub

   End Class
End Namespace
