﻿Imports System.Collections.ObjectModel

Namespace System

   Public Class UriList : Inherits ObservableCollection(Of Uri)

      Public Sub New(commonUriPart As String, ParamArray files As String())
         If Not commonUriPart.EndsWith("/") Then commonUriPart += "/"c
         For Each s In files
            MyBase.Add(New Uri(commonUriPart & s.Trim()))
         Next
      End Sub
   End Class

End Namespace
